function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, JoinColumn, Column, ManyToOne, Index } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
export let AttestationChallenge = class AttestationChallenge {
    id;
    userId;
    user;
    challenge;
    createdAt;
    registrationChallenge;
    constructor(data){
        if (data == null) return;
        for (const [k, v] of Object.entries(data)){
            this[k] = v;
        }
    }
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], AttestationChallenge.prototype, "id", void 0);
_ts_decorate([
    Index(),
    PrimaryColumn(id()),
    _ts_metadata("design:type", Object)
], AttestationChallenge.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], AttestationChallenge.prototype, "user", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        length: 64,
        comment: "Hex-encoded sha256 hash of the challenge."
    }),
    _ts_metadata("design:type", String)
], AttestationChallenge.prototype, "challenge", void 0);
_ts_decorate([
    Column("timestamp with time zone", {
        comment: "The date challenge was created for expiry purposes."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], AttestationChallenge.prototype, "createdAt", void 0);
_ts_decorate([
    Column("boolean", {
        comment: "Indicates that the challenge is only for registration purposes if true to prevent the challenge for being used as authentication.",
        default: false
    }),
    _ts_metadata("design:type", Boolean)
], AttestationChallenge.prototype, "registrationChallenge", void 0);
AttestationChallenge = _ts_decorate([
    Entity(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [
        typeof Partial === "undefined" ? Object : Partial
    ])
], AttestationChallenge);
